package Caching;
import java.lang.*;
import java.util.*;
import StartAllServers.Debug;

  public class BufferEntry {
    
      String url;
      Date modified_on = null;
      Date expires_on = null;
      Date retrieved_on = null;
      String folder = "public"; 
      
      /**
       * Overwrote the toString method speciically for this class
       */
      public String toString() {
	  return "\n[*******\n" + "URL: " + url + "\n" + 
	      "Modified On: " + modified_on + "\n" +
	      "Expires On: " + expires_on + "\n" +
	      "Retrieved On: " + retrieved_on  + "\n" +
	      "Folder: " + folder + "\n*******]\n";
      }


      /**
       * Make a copy of this object.
       */
      public Object clone() {
	  BufferEntry entry = new BufferEntry();
	  entry.setUrl(this.url);
	  entry.setModified(this.modified_on);
	  entry.setExpired(this.expires_on);
	  entry.setRetrieved(this.retrieved_on);
	  entry.setFolder(this.folder);
	  return entry;
      }
	  

      /**
       * Get the contents of the URL field
       */
      public String getUrl() {
	  return url;
      }

      /**
       * Get the date when the url was last modified on the server
       */
      public Date getModified() {
	  return modified_on;
      }

      /**
       * Get the date when the url was retrieved by someone or yourself
       */
      public Date getRetrieved() {
	  return retrieved_on;
      }

       /**
       * Get the date when the url will expire
       */
      public Date getExpired() {
	  return expires_on;
      }

      /**
       * Get the folder where this url is located 
       */
      
      public String getFolder() {
	  return folder;
      }

      /**
       * Set the URL field of this object
       */
      public boolean setUrl(String url) {
	  this.url = url;
	  return true;
      }

      /**
       * Set the field indicating when the URL was last modified
       */
      public boolean setModified(Date modified) {
	  this.modified_on = modified;
	  return true;
      }

      /**
       * Set the field when the URL will expire
       */
      public boolean setExpired(Date expired) {
	  this.expires_on = expired;
	  return true;
      }

      /**
       * Set the field when the URL was retrieved
       */
      public boolean setRetrieved(Date retrieved) {
	  this.retrieved_on = retrieved;
	  return true;
      }

      /**
       * Set the folder where this link will reside
       */

      public boolean setFolder(String infolder) {

	  if (infolder.trim().equals("private")) {
if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println("FOLDER IS PRIVATE"); 
 	} 
 	}
	      folder = "private";
	      return true;
	  }
	  
	  if (infolder.trim().equals("public")) {
	      folder = "public";
	      return true;
	  }
	  
	  return false;
      }
	      
	    

  }
      
    
