package Caching;
import java.io.*;
import java.lang.*;
import java.util.*;
import HTTPClient.*;

import StartAllServers.Debug;
public class CacheManager extends Thread {

    long INVOKE_TIME;
    int IN_CACHE;

    public CacheManager(long how_often, long length_in_cache) {
	this.INVOKE_TIME = how_often;
	this.IN_CACHE = (int) length_in_cache;
	initialize();
    }

    private void initialize() {
	
	//if the cache dir not create, create the cache dir
	try {
	    File cache_dir = new File(Constants.CACHE_DIR);
	    File glimpse_files = new File(Constants.GLIMPSE_GEN_FILES);
	    
	    
	    if (!cache_dir.exists()) {
		cache_dir.mkdir();
	    } 
	    
	    if (!glimpse_files.exists()) {
		glimpse_files.mkdir();
       	    } 

	} catch (Exception e) {
	    e.printStackTrace();
	}
    
    }


    public void run() {
	while (true) {
	    CacheBuffer cb = CacheBuffer.getInstance();
	    Hashtable hash = cb.giveBuffer();
	    
	    for (Enumeration e = hash.elements(); e.hasMoreElements();) {
		BufferEntry entry = (BufferEntry) e.nextElement();
		//Date current_date = new Date();
		Calendar current_time = Calendar.getInstance();
		Calendar expiration_time = Calendar.getInstance();
		String url = entry.getUrl();
		Calendar removal_time = Calendar.getInstance();
		

		if (entry.getExpired() != null)
		    expiration_time.setTime(entry.getExpired());
		    if (expiration_time.before(current_time)) {
			System.out.println("The entry " + url + "has expired...Removing because current date is:" + current_time.getTime() + "and expiration time is:" + expiration_time.getTime());
			deleteCache(cb, entry);
		    }
	    
		
		else if (entry.getRetrieved() != null)
		    removal_time.setTime(entry.getRetrieved());
		    System.out.println("Got this on: " + entry.getRetrieved());
		    System.out.println("In cache is: " + IN_CACHE);
		    removal_time.add(Calendar.MINUTE, IN_CACHE);

		    if (removal_time.before(current_time)) {
			System.out.println("The entry " + url + "has been sitting in the cache too long...Removing because current time is:" + current_time.getTime() + "and was supposed to be removed on:" + removal_time.getTime());
			deleteCache(cb, entry);
		    }
	    }
			 
	    
	    try {
		Thread.sleep(INVOKE_TIME);
	    } catch (Exception e) {
		System.err.println(e.getMessage());
	    }
	}
    }

    private void deleteCache(CacheBuffer cb, BufferEntry entry) {
	String path;
	String url = entry.getUrl();
	if (url.trim().endsWith("/")) {
	    url = url.trim().concat("index.html");
	}
	int index = url.indexOf("//");
	path = (new String(Constants.CACHE_DIR + "/")).concat(url.substring(index+2));
	cb.deleteBufferEntry(entry);
	
	File first = new File(path);
	first.delete();
	deleteDirs(path);

    }

    //delete all the empty directories that exist
    public boolean deleteDirs(String fName) {
	
	if (fName.lastIndexOf("/") < 0)
	    return true;
	
	fName = fName.substring(0, fName.lastIndexOf("/"));
	File object = new File(fName);
	//System.out.println("The filename in recursion is: " + fName);


	if (fName.trim().equals(Constants.CACHE_DIR)) 
	    return true;

	if (object.isDirectory())
	    if (object.listFiles().length == 0) {
		object.delete();
		return deleteDirs(fName);
	    }

	return true;
    }


    public static void main(String argv[]) {
	String path = (new String(Constants.CACHE_DIR + "/")).concat("www.cs.brandeis.edu/index.html");
	//File first = new File(path);

	//first.delete();
	//deleteDirs(path);
    }
}    
