package Caching;
import java.util.*;
import java.lang.*;

import StartAllServers.Debug;
public class CacheTreeNode{

    public Vector children = new Vector();

    public String localval = new String();  //This is the value that will be displayed
    public String globalval = new String();
    public int depth= 0;
    public boolean expanded = false;
    public boolean root = true;
    
    String folder = "public";

    public CacheTreeNode getChild(int i){
	return (CacheTreeNode)children.elementAt(i);
    }

    
    public void add(String input){      //The input will be an absolute string
	//The method adds the string by creating all nodes into the tree
	//and setting their values

	//Parse the string going through each directory.  To this I'll tokenize it
	int begin = input.indexOf("://");
	String temp = input.substring(begin+3);
	
	StringTokenizer tokens = new StringTokenizer(temp, "/");
	CacheTreeNode holder = this;

	while(tokens.hasMoreTokens()){
	    String s = tokens.nextToken();
	    int x = holder.hasNode(s);
	    if (x>=0){
		holder = (CacheTreeNode)holder.children.elementAt(x);
	    }

	    else {
		CacheTreeNode newctn = new CacheTreeNode();
		newctn.root=false;
		newctn.globalval = holder.globalval + "/" + s;
		if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println("Global has string " + globalval); 
 	} 
		}
		newctn.localval = s;
		newctn.depth = holder.depth +1;
		holder.children.addElement(newctn);
		holder = (CacheTreeNode)holder.children.lastElement();
		
	    }
	    
	}
	
    }
    
    
    //Take a global URL and return all of the leaf nodes under it
    //no http:// at begining
    public Vector getLeafGlobalVals(String inpath){
	
	StringTokenizer tokens = new StringTokenizer(inpath, "/");
	Vector paths = new Vector();
	
	CacheTreeNode holder = this;
	while(tokens.hasMoreTokens()){
	    int n;
	    if( (n = holder.hasNode(tokens.nextToken()) ) >= 0){
		holder = (CacheTreeNode)holder.children.elementAt(n);
	    }
	    else return paths;
		
	}
	//Now holder is at the end of the path in the tree

	getPaths(holder, paths);
	
	return paths;

    }



    private void getPaths(CacheTreeNode node, Vector paths){
	
	if (node.children.size() ==0 ){
	    paths.addElement(node.globalval);
	}
	else { 
	    for(int i=0; i<node.children.size(); i++){
		getPaths( (CacheTreeNode)node.children.elementAt(i), paths);
	    }
	}
	    
		

    }

    //Takes a value for a local path and searches the children for it
    private int hasNode(String local){
	for (int i=0; i< children.size(); i++){
	    
	    if( ((CacheTreeNode)children.elementAt(i)).localval.equals(local))
		return i;
	}
	
	return -1;
    }
    
    public void unExpandAll(CacheTreeNode holder){
	
	if (holder.children.size() == 0 )
	    holder.expanded = false;
	else{
	    holder.expanded = false;
	    
	    for(int i=0; i<holder.children.size(); i++){
		unExpandAll(holder.getChild(i));
	    }
	    
	}
	
    }
    

    public void expandToggle(String path){
	
	StringTokenizer tokens = new StringTokenizer(path, "/");
	
	CacheTreeNode holder = this;
	while(tokens.hasMoreTokens()){
	    int n;
	    if( (n = holder.hasNode(tokens.nextToken()) ) >= 0){
		holder = holder.getChild(n);
	    }
	    
	}
	//Now holder is at the end of the path in the tree
	
	if (holder.expanded == true)
	    holder.expanded = false;
	else holder .expanded = true;
	
    }
    
    public static void printTree(CacheTreeNode ctn){
	if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println(ctn.localval); 
 	} 
 	}
	if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println(ctn.globalval); 
 	} 
 	}
	if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println(""); 
 	} 
 	}
	
	for(int i=0; i<ctn.children.size(); i++){
	    
	    printTree((CacheTreeNode)ctn.children.elementAt(i));
	}
	
    }
    
    /**
     * Get the folder where this url is located 
     */
    
    public String getFolder() {
	return folder;
    }
    
    /**
     * Set the folder where this link will reside
     */
    
    public boolean setFolder(String infolder) {

	if (infolder.trim().equals("private")) {
	    if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println("FOLDER IS PRIVATE"); 
 	} 
	    }
	    folder = "private";
	    return true;
	}
	
	if (infolder.trim().equals("public")) {
	    folder = "public";
	    return true;
	}
	
	return false;
    }
    
    /**
     * Get the local path value 
     */
    
    public String getLocal() {
	return localval;
    }
    
    /**
     * Get the local path value 
     */
    
    public String getGlobal() {
	return globalval;
    }
    
    
    
    
    
    public static void main(String args[]){
	
	CacheTreeNode Tree = new CacheTreeNode();
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println("root is " + Tree.getGlobal()); 
 	}

	Tree.add("http://ads.nytimes.com/RealMedia/ads/adstream_lx.ads");
	Tree.add("http://ads.nytimes.com/RealMedia/ads/newleaf1.html");
	Tree.add("http://www.BostonTimes.com/RealMedia/ads/adstream_lx.ads");
	CacheTreeNode.printTree(Tree);
	
	Vector paths = Tree.getLeafGlobalVals("ads.nytimes.com/RealMedia/");
	for(int i=0; i<paths.size(); i++){
	    if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println( (String)paths.elementAt(i)); 
 	} 
	    }
	}
	
	paths = Tree.getLeafGlobalVals("ads.nytimes.com/RealMedia/ads/newleaf1.html");
	for(int i=0; i<paths.size(); i++){
	    if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println( (String)paths.elementAt(i)); 
 	} 
	    }
	}
	
	paths = Tree.getLeafGlobalVals("adfasdfasdfas");
	for(int i=0; i<paths.size(); i++){
	    if (Debug.DEBUG_Caching == true) { 
if (Debug.DEBUG_Caching == true) { 
 	 System.out.println( (String)paths.elementAt(i)); 
 	} 
	    }
	}
	
    }
    
    
    
}
	 


