package Caching;

import java.io.File;
import java.io.*;
import java.net.*;
import java.lang.*;
import HTTPClient.*;
import HTTPMethods.*;

/**
 * <Design Spec> Given a web page, cache it.
 * web page related functions
 * hate to use URI, file mapping, but whatever you ask.
 **/
import StartAllServers.Debug;
public class HandleWebPage 
{
  //this flag is important to solve the sync problem of glimpseindex.
  //if several glimpses is running, the results will be very bad
  public HandleWebPage()
  { }


    //Written by DA
    //basically given a url this will return 
    public boolean FileisInCache(String request, boolean restricted) {
	request = request.trim();
	
	if (restricted) {
	    CacheBuffer cb = CacheBuffer.getInstance();
	    BufferEntry entry = cb.getBufferEntry(request);
	    if (entry == null){
		System.out.println("_____________________ENTRY NOT FOUND  " + request);
		return false;
	    }
	    
	    
	    else if (entry.getFolder().trim().equals("private")){
		System.out.println("_____________________FAILED DUE TO PRIVATE");
		System.out.println(entry);
		return false;
	    }
	    
	}

	//this is a http page serve
	String fileName = request.substring(7);
	fileName=ParseRequest.attachIndexHtml(fileName);
	File file = new File(new String(Constants.CACHE_DIR) + "/" + fileName);
	System.out.println("The file to be sent is: " + file);
	return file.exists();
    }


    //get the data from the cache
    //Written by DA
    public boolean getFromCache(String url, DataOutputStream os) {
	int end;

	if (Debug.DEBUG_Caching == true) { 
	    System.out.println("%%%%%%%%%%%%%%%%% Getting from cache %%%%%%%%%%%%%%"); 
 	
 	}
	if (url.trim().endsWith("/")) {
	    url = url.trim().concat("index.html");
	}
	int index = url.indexOf("//");
	String fName = (new String(Constants.CACHE_DIR + "/")).concat(url.substring(index+2));
 
	if (Debug.DEBUG_Caching == true) { 
	    System.out.println("%%%%%%%%%%%% FILENAME IS: " + fName + " %%%%%%%%%%%%%%%%%"); 
 	} 
 	
	try {
	    File file = new File(fName);
	    FileInputStream fin = new FileInputStream(file);
	    byte b[] = new byte[1024];
	    int l;

	    while ((l = fin.read(b)) > 0) {
		os.write(b, 0, l);
	    }

	    return true;
	    
	} catch (FileNotFoundException e) {
	    System.err.println("File not found: " + fName);
	    return false;
	} catch (SecurityException e) {
	    System.err.println("Security problem with: " + fName);
	    return false;
	} catch (IOException e) {
	    System.err.println("IOException: " + e.getMessage());
	    return false;
	}
    }

    //cache the web page if doICache returns true
    public void cache(String request, HTTPResponse rsp, byte[] data) {

	String URL = ParseRequest.getURL(request);
	try {
	    //cache if need be
	    if (doICache(request)) {
		FileOutputStream fout = saveToCache(URL);
		fout.write(data, 0, data.length);
		
		//add to the buffer
		CacheBuffer mybuffer = CacheBuffer.getInstance();
		mybuffer.addURLToBuffer(ParseRequest.attachIndexHtml(URL), rsp);
	    }
	} catch (Exception e) {
	   e.printStackTrace();
	}
    }   
	
    //this method is only called when a web page comes by way
    //of pre-fetching as used in the WebClient. We DEFINITELY
    //need to cache it if we decided to pre-fetch it.
    public void cache(URL myurl, HTTPResponse rsp, byte[] data) {
	
	String URL = myurl.toString();
	try {
	    
	    FileOutputStream fout = saveToCache(URL);
	    fout.write(data, 0, data.length);
	    
	    //add to the buffer
	    CacheBuffer mybuffer = CacheBuffer.getInstance();
	    mybuffer.addURLToBuffer(ParseRequest.attachIndexHtml(URL), rsp);

	} catch (Exception e) {
	    System.err.println("In handleWebPage: " + e.getMessage());
	}
    }

    
	

    //Do I cache the current page?
    public boolean doICache(String request) {
	String URL = ParseRequest.getURL(request);

	//block everything to/from the local host
	if (!ParseRequest.addressedToMyHost(request))
	    return true;
	
	//otherwise don't cache
	return false;
	
    }
  
  

    // Written by DA
    //I need it to return a file output stream
    public FileOutputStream saveToCache(String url) {
	int index = url.indexOf("//");
	String fName = (new String(Constants.CACHE_DIR + "/")).concat(url.substring(index+2));
	//make sure to deal with the case of no specified file correctly
	
	fName = ParseRequest.attachIndexHtml(fName);
	
	/*
	if (fName.trim().endsWith("/")) 
	    
	    fName = fName.concat("index.html");
	*/
	if (Debug.DEBUG_Caching == true) { 
	    System.out.println("CACHE: Creating: " + fName); 
 	
 	}
	try{
	    File file = new File(fName);
	    index = fName.lastIndexOf('/');
	    String dirName = fName.substring(0, index);
	    //System.out.println("fName=" + fName + "dirName=" + dirName);
	    File dir = new File(dirName);
	    dir.mkdirs();
	    file.createNewFile();
	    FileOutputStream fout = new FileOutputStream(file);
	    return fout;
	} catch (Exception e) {
	   
	    if (Debug.DEBUG_Caching == true) { 
		System.out.println(e.getMessage()); 
	    } 
 	
	}
	return null;
    }
}
