package GUIServer;

import java.io.*;
import java.net.*;
import java.util.*;


public class GenerateSearch{

    public GenerateSearch(){
    }
    
    public GenerateSearch(Socket in_socket){
	
	try{
	    OutputStream o = in_socket.getOutputStream();
	    
	    PrintWriter myout = new PrintWriter(o, true);

	    QueryReportBuffer myquery = QueryReportBuffer.getInstance();
		    

	    //Generate the search part of the query
	    myout.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"> ");
	    myout.println("<HTML NAME=\"MAIN\">  ");
	    myout.println("<HEAD>  ");

	    /***Add this line for allowing the page to refresh based on the configuration***/
	    myout.println("<META HTTP-EQUIV=\"refresh\" CONTENT=" + myquery.updatefreq + ">");

	    myout.println("  <TITLE>Wireless Data Sharing Network</TITLE>  ");
	    myout.println("</HEAD> ");
	    myout.println("<CENTER> ");
	    myout.println("<H1>Wireless Data Sharing Network</H1> ");
	    myout.println("</CENTER><BR> ");
	    myout.println("<BODY bgcolor=\"white\" text=\"black\" marginwidth=\"0\" marginheight=\"0\" leftmargin=\"0\" topmargin=\"0\"> ");
	    myout.println("<FORM ACTION=\"http://localhost:9009/QuerySearch\">");
	    myout.println("<Center> ");
	    
	    myout.println("<FONT face=\"arial black\" size=4 color=\"blue\"><I> ");
	    myout.println("Enter Keywords or URL: ");
	    myout.println("</I></FONT> ");
	    myout.println("<INPUT TYPE=\"TEXT\" NAME=\"query\" SIZE=\"40\"><BR><BR> ");
	    myout.println("   <INPUT TYPE=\"SUBMIT\" VALUE=\"Search\"> ");
	    myout.println(" </CENTER></FORM> ");
	    
	    
	    myout.println(" <form><input type=\"button\" value = \"Configuration\" onClick=\"javascript:window.open('CONFIG','Configuration','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0,width=480,height=380')\"> </form> ");

	    myout.println(" <form><input type=\"button\" value = \"CacheViewer\" onClick=\"javascript:window.open('CACHE','CacheViewer','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=900,height=600')\"> </form> ");

	    
	 
	    myout.println("<FORM>");//    ACTION=\"http://localhost:9009/Update\">");
	    myout.println("   <INPUT TYPE=\"SUBMIT\" VALUE=\"Update\"> ");

	    myout.println("</FORM>");
	 
	    myout.println("<HR align=\"center\" size=\"3\" width=\"100%\"> ");


	    //Generate the list of queries in the QueryReportBuffer that are viewable
	    myout.println("<H2><I> ");
	    myout.println("Query Results: </I></H2> ");
	 
	    showQueries(myquery.queries, myout);
	    
	    myout.println("</BODY></HTML> ");

	    
	    
	}
	catch (IOException e) {System.err.println(e.getMessage());
	}
	
	
    }

    

    //This method takes a query report buffer and and a Printstream and outputs the 
    //queries and their results to the web page
    private void showQueries(Vector queries, PrintWriter myout){
	
	myout.println("<TABLE position=center><TR><TD></TD><TD>");
	myout.println("<pre>");
	
	//traverse all of the queries
	for (int i=0; i<queries.size(); i++){
	    Query qtemp = (Query)queries.elementAt(i);
	    //for each query, show the descriptor
	    if(qtemp.viewable){

		//print the query descriptor in blue

		String noSpace = qtemp.descriptor.replace(' ', '+');
		
		myout.println("<a href=\"expand:" + i + "\">");
		myout.println("<FONT color=\"brown\" size=4><B>Query " + i + ": " +  qtemp.descriptor + "</B></FONT>" );
		myout.println("</a>");

		if (qtemp.expanded){
		    //now print out all of the viewable reports
		    for(int j=0; j<qtemp.reports.size(); j++){
			Report rtemp = (Report)qtemp.reports.elementAt(j);
			if(rtemp.viewable){
			    myout.println("     " + rtemp.title);
			    myout.println("     " + rtemp.age);
			    myout.println("     <a href=\"" + rtemp.origURL + "\" " + "target=" + "\"" +  rtemp.title + "\" >" + rtemp.origURL  + "</a><BR><BR>");
			    
			}
			
		    }
		}
		myout.println("<BR>");
		
	    }
	    else{  //print the query descriptor alone in gray font
		myout.println("<FONT color=\"gray\" size=4>Query " + i + ": " +  qtemp.descriptor + "</FONT><BR><BR>" );
	    }
	}
	myout.println("</pre></TD></TR></TABLE>\n");

    }

}



