package GUIServer;

import java.net.*;
import java.io.*;
import java.lang.*;
import java.lang.reflect.*;
import java.util.*;
import UDPMulticast.*;
import StartAllServers.*;
import HTTPMethods.*;
import Caching.*;


public class GuiMain {
    Socket client_to_server = null;
    String req_received = "";
    String message_to_send = "";
    public final boolean error = true;
    public final boolean no_error = false;

    //Constructor
   public GuiMain(Socket socket) {
	this.client_to_server = socket;
    }


    //when we get a set of keywords we will just issue a multicast boradcast
    public void querySend(String query) {
	
	String localhost_IP = "";
	String varName = new String("?query=");
	
	int begin = query.indexOf("?query=") + varName.length();
	int end = query.indexOf("HTTP");
	String snd = query.substring(begin, end-1);
	snd = snd.replace('+', ' ');

	QueryReportBuffer mybuffer = QueryReportBuffer.getInstance();
	
	try {
	    localhost_IP = InetAddress.getByName("localhost").getHostAddress();
	} catch (UnknownHostException e) {
	    System.err.println("Can't resolve localhost");
	}
	
	//if(!ParseRequest.addressedToMyHost(snd.trim() )){
	    System.out.println("Broadcasting Query: " + snd );
	    //	replyMess("Broadcasting Message: " + snd +"\n");
	    
	    new MulticastSendThread(StartAllServers.UDP_mult_port, snd, mybuffer.numbroadcasts).start();
	

	    if(snd.length() !=0 )
		mybuffer.addQuery(snd);
	    //}
	GenerateSearch gs = new GenerateSearch(client_to_server);
    }			 

    //parse out the request and see how we can serve it
    public void parseAndDecide(String req_received) {
	req_received = ParseRequest.remove_referer(req_received);
	int pos;

	System.out.println("RRRRRRRRRRRRRRRRRRRR" + req_received + "RRRRRRRRRRRRRRRRRRRR");


	if( req_received.indexOf("Update") > -1){
	    GenerateSearch gs = new GenerateSearch(client_to_server);
	}	
	
	else if ( (pos = req_received.indexOf("expand:")) > -1 ){
	    int end = req_received.lastIndexOf(" HTTP");
	    String descriptor = req_received.substring(pos + 7, end);
	    //descriptor = descriptor.replace('+', ' ');

	    QueryReportBuffer qrb = QueryReportBuffer.getInstance();
	    qrb.expandQuery(descriptor);
	    
	    GenerateSearch gs = new GenerateSearch(client_to_server);
	}
	
	else if ((pos = req_received.indexOf("QuerySearch?query=")) > -1 ){
	    
	    querySend(req_received);
	}

	else if ((pos = req_received.indexOf("LOCKOFF*&*")) > -1 ){
	    
	    ServeFile sf = new ServeFile(client_to_server, "GUIServer/unlock.gif");
	    sf.fileSend();
	}

	else if ((pos = req_received.indexOf("LOCK*&*")) > -1 ){
	    
	    ServeFile sf = new ServeFile(client_to_server, "GUIServer/lock.gif");
	    sf.fileSend();
	}

	else if ((pos = req_received.indexOf("MAG*&*")) > -1 ){
	    
	    ServeFile sf = new ServeFile(client_to_server, "GUIServer/mag.gif");
	    sf.fileSend();
	}

	else if ((pos = req_received.lastIndexOf("SECURE*&*")) > -1 && pos > req_received.lastIndexOf("SECUREOFF*&*") && pos > req_received.lastIndexOf("SHOWMORE&") ){
	    int end = req_received.indexOf("&&");
	    pos += 9;
	    String url = req_received.substring(pos, end);
	    System.out.println("UUUUUUURL is " + url);
	    CacheBuffer cb = CacheBuffer.getInstance();

	    Vector urls = cb.Tree.getLeafGlobalVals(url);
	    for(int i=0; i<urls.size(); i++){
		url = (String)urls.elementAt(i);
		BufferEntry be = cb.getBufferEntry("http:/" +url);
		be.setFolder("private");
		cb.updateBuffer(be.getUrl(), be);
		System.out.println("+++++++++++++Setting to Private");
		System.out.println("FOLDER IS " + be.getFolder());
	    }
	    GenerateCacheViewer gc = new GenerateCacheViewer(client_to_server);
	    
	}


	else if ((pos = req_received.lastIndexOf("SECUREOFF*&*")) > -1 && pos > req_received.lastIndexOf("SECURE*&*") && pos > req_received.lastIndexOf("SHOWMORE&")){
	    int end = req_received.indexOf("&&");
	    pos += 12;
	    String url = req_received.substring(pos, end);

	    CacheBuffer cb = CacheBuffer.getInstance();
	    
	    Vector urls = cb.Tree.getLeafGlobalVals(url);
	    for(int i=0; i<urls.size(); i++){
		url = (String)urls.elementAt(i);
		BufferEntry be = cb.getBufferEntry("http:/" +url);
		be.setFolder("public");
		cb.updateBuffer(be.getUrl(), be);
		System.out.println("+++++++++++++Setting to Public");
		System.out.println("FOLDER IS " + be.getFolder());
	    }
	    
	    GenerateCacheViewer gc = new GenerateCacheViewer(client_to_server);
	    
	}

	else if ((pos = req_received.lastIndexOf("SHOWMORE&")) > -1 && pos > req_received.lastIndexOf("SECURE*&*") && pos > req_received.lastIndexOf("SECUREOFF*&*")){
	    int end = req_received.indexOf("&&");
	    pos+= 9;
	    String url = "http:/" + req_received.substring(pos, end);
	    System.out.println("URL IS " + url);
	    GenerateDetails gc = new GenerateDetails(client_to_server, url);
	    
	}



	else if ((pos = req_received.indexOf("APPLYCONFIG")) > -1 ){
	    
	    QueryReportBuffer qrb = QueryReportBuffer.getInstance();
	    
	    //ENTER CODE TO PARSE INPUT FROM CONFIG TOOL
	    System.out.println("parsing config: " + req_received);
	    
	    try{

		//Parse out updatefreq
		int x = req_received.indexOf("UPDATEFREQ=");
		x += 11;
		qrb.updatefreq = (new Integer(req_received.substring(x, req_received.indexOf("&", x)))).intValue();
		System.out.println("Set updatefreq to " + qrb.updatefreq);
		
		//Parse out broadcast freq
		x = req_received.indexOf("BROADCASTFREQ=");
		x += 14;
		qrb.broadcastfreq = (new Integer(req_received.substring(x, req_received.indexOf("&", x)))).intValue();
		System.out.println("Set broadcastfreq to " + qrb.broadcastfreq);
		//Parse out numbbroadcasts
		x = req_received.indexOf("NUMBROADCASTS=");
		x += 14;
		qrb.numbroadcasts = (new Integer(req_received.substring(x, req_received.indexOf("&", x)))).intValue();
		System.out.println("Set numbroadcasts to " + qrb.numbroadcasts);
		//Parse out bufferfreq
		x = req_received.indexOf("BUFFERFREQ=");
		x += 11;
		qrb.bufferfreq = (new Integer(req_received.substring(x, req_received.indexOf("&", x)))).intValue();
		System.out.println("Set bufferfreq to " + qrb.bufferfreq);
		
	     	//Parse out cleancache value
		x = req_received.indexOf("CLEANCACHE=");
		x += 11;
		qrb.cleancache = (new Integer(req_received.substring(x, req_received.indexOf("&", x)))).intValue();
		System.out.println("Set cleancache to " + qrb.cleancache);
		
		//Parse out expires
		x = req_received.indexOf("EXPIRES=");
		x += 8;
		int expires = (new Integer(req_received.substring(x, req_received.indexOf("&", x)))).intValue();

		CacheBuffer cb = CacheBuffer.getInstance();
		Calendar now = Calendar.getInstance();
		now.add(Calendar.HOUR, expires);
		Date exp = now.getTime();
		
		Object[] arr = cb.giveBuffer().values().toArray();
		BufferEntry be = new BufferEntry();
		
		int size = Array.getLength(arr);
		
		for(int i=0; i<size; i++){
		    be = (BufferEntry)arr[i];
		    if(be.getExpired() == null){
			be.setExpired(exp);
			cb.updateBuffer(be.getUrl(), be);
		    }
		}
		System.out.println("Set Expires to " + exp);

		
		//Parse out energy
		x = req_received.indexOf("ENERGY=");
		x += 7;
		String energystr = req_received.substring(x, req_received.indexOf(" HTTP", x));
		boolean energyval=false;
	        if (energystr.compareToIgnoreCase("true") == 0) energyval=true;
		qrb.energy=energyval;
		System.out.println("Set Energy to " + energyval);
		

		GenerateConfig gc = new GenerateConfig(client_to_server);
		
	    }catch (NumberFormatException e){
		GenerateNumFormatError gc = new GenerateNumFormatError(client_to_server);
	    }

	    
	    
	}
	
	else if ((pos = req_received.indexOf("CONFIG")) > -1 ){
	    
	    GenerateConfig gc = new GenerateConfig(client_to_server);
	}

	else if ((pos = req_received.indexOf("CACHE")) > -1 ){
	    
	    GenerateCacheViewer gc = new GenerateCacheViewer(client_to_server);
	}

	//don't send a multicast if this is really addressed to me
	//like if the user types localhost:9009 at the Netscape window
	else if (ParseRequest.addressedToMyHost(req_received)) {
	    yourNetworkisDown();
	}
	
	   
	else {
	    
	    urlSend(req_received);
	    yourNetworkisDown();
	    
	}
	
    }
    

    public void urlSend(String req){
	
	String host = ParseRequest.getHostName(req, false);
	String filename = ParseRequest.getFilename(req);
	
	int space = filename.indexOf(' ');
	if (space != -1) filename = filename.substring(0, space);
	
	String fin = "http://" + host + filename;
	fin = fin.trim();
	if (fin.endsWith("/") )
	    fin = fin + "index.html";
	if(!ParseRequest.addressedToMyHost(fin.trim() )){
	    System.out.println("|||||||||||||||Sending query " + fin);
	    new MulticastSendThread(StartAllServers.UDP_mult_port, fin, 10).start();
	
	    QueryReportBuffer qrb = QueryReportBuffer.getInstance();
	    qrb.addQuery(fin);
	}
	
    }
    
    
    
    //return the page called "Your Network is down"
    public void yourNetworkisDown() {

	GenerateSearch gs = new GenerateSearch(client_to_server);
	
    }
    

     // Send a message back to Netscape
     public boolean replyMess (String message) {
	OutputStream outt;
	DataOutputStream os;

	System.out.println("Socket is: " + client_to_server);
	try {
	     //get raw streams
	    outt = client_to_server.getOutputStream();
	    
	    //turn into PrintWriter streams
	    os = new DataOutputStream (outt);

	    //check streams
	    if (outt == null || os == null) {
		System.err.println("Failed to open streams");
		cleanUp();
		return error;
	    }

	    // send the message
	    System.out.println ("*********Writing to Netscape: \n" + message + "\n");
	    os.write(new String(message).getBytes());
	    //cleanUp();

	} catch (UnknownHostException e) {
	    System.err.println(e.getMessage());
	    cleanUp();
	    return error;
	} catch (IOException e) {
	    System.err.println(e.getMessage());
	    cleanUp();
	    return error;
	}
	return no_error;
     }




    //close all sockets that are still open
    public void cleanUp() {
	System.err.println("Closing All sockets");
	try {
	    if (client_to_server != null)
		client_to_server.close();
	} catch (IOException e) {
	    System.err.println(e.getMessage());
	}
    }

}

