package GUIServer;

import java.util.*;
import Caching.*;
import WebClient.*;
import HTTPMethods.*;

public class Query{

    private Date newestDate = new Date (00000);  //Marks the date of the newest web page. 
    //Initialized to a very old date
    private String newestURL = null;  //Used for the URL of the latest job for that queue
    //Initialized to null;
    
    //As reports are added, if a newer report is found, the above values are modified for it.
    
    public Vector reports = new Vector();  //The list of reports that correspond
                                    //to this Query
    public String descriptor = new String("");    //The Identifier

    public boolean viewable = false;

    public boolean expanded = false;  //keeps track of whether the query's reports are showing
    
    public void addReport(Report r){
	
	if (!hasReport (r) ){
	    //System.out.println("++++++++Adding Report to buffer");
	    reports.addElement(r);

	}
	//Use this to modify the newestDate variable as we go along
	if(r.age.after(newestDate)){ //if r is has date newer than newestDate
	    //System.out.println("SSSSSSSSSSETTING NEWEST URL HERE");
	    newestDate = r.age;
	    newestURL = r.localURL;
	    
	}
	
    }

    public boolean hasReport(Report r){
	for (int i=0; i<reports.size(); i++){
	    Report temp = (Report)reports.elementAt(i);
	    if ( temp.title.equals(r.title)
		 && temp.origURL.equals(r.origURL)
		 //&& temp.localURL.equals(r.localURL) 
		 //&& temp.age.equals(r.age)
		 ){
		return true;
	    }
	}
	return false;
    }

	

    //Since newestURL was set to have the date of the latest URL as 
    //reports were being added, we know it has the latest URL
    public void findLatestReport(){
	//System.out.println("++++++++descriptor is " + descriptor);
	//System.out.println("+++++++++localurl is " + localURL);
	

	HandleWebPage hp = new HandleWebPage();

	if(newestURL != null){
	    if(hp.FileisInCache(ParseRequest.stripHostname(newestURL) )){
		System.out.println("^^^^^^^^^Setting " + newestURL.trim() + "to viewable");
		setViewable(newestURL.trim());
	    }
	    
	    else if(newestURL != null){
		System.out.println("STRIPPED URL IS " + ParseRequest.stripHostname(newestURL));
		String retURL = newestURL.trim();
		
		System.out.println("+++++++++Retrieving page " + retURL);
		
		
		WebRetrieve myclient = new WebRetrieve(retURL);
		boolean cached = myclient.sendRequest();
		
		if(cached){
		    System.out.println("^^^^^^^^^Setting " + retURL + "to viewable");
		    setViewable(retURL);
		}
		//set the viewable variable to true for the query at hand
	    }
	}
	    
    }
    
    
    private void setViewable(String url){   //sets all of the reports in the buffer to 
	//have a viewable flag of true;
	
	//go through each report
	for (int j=0; j< reports.size(); j++){
	    if (url.equals ( ((Report)reports.elementAt(j)).localURL ) ){
		((Report)reports.elementAt(j)).viewable=true;
		//tell that query that it has some viewable reports
		viewable = true;
	    }
	}
    }


    

}


