package GUIServer;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import java.io.IOException;
import org.w3c.dom.*;
import org.apache.xerces.dom.DocumentImpl;
import  org.apache.xml.serialize.OutputFormat;
import  org.apache.xml.serialize.Serializer;
import  org.apache.xml.serialize.SerializerFactory;
import  org.apache.xml.serialize.XMLSerializer;
import java.io.*;
import org.xml.sax.InputSource;
import java.util.*;


//This class is instantiated each time an initial response is received
//from a peer.  It contains an integer value to identify the Query that
//it corresponds to.

public class Response{
    

    //Return a query that contains all necessary items after parsing
    //the xml string
    public Query parseResponse( String xml_report){
	
	Query q_return = new Query();
	
	StringReader strR = new StringReader(xml_report);
	InputSource is = new InputSource (strR);
	
	DOMParser parser = new DOMParser ();

	//System.out.println("!!!!!!!!!!PARSING XML : " + xml_report);

	try {
	    parser.parse(is);
	    
	} catch (SAXException se) {
	} catch (IOException ioe) {
	}

	Document rep_doc = parser.getDocument();
	
	//get the query name from this query
	//get the query name of in_resp
	NodeList qs = rep_doc.getElementsByTagName("QueryDescriptor");
	Node q = qs.item(0);
	String queryN = q.getFirstChild().getNodeValue();
	
	//System.out.println(queryN);
	q_return.descriptor = queryN;

	NodeList in_reports = rep_doc.getElementsByTagName("Report");

	for (int i=0; i<in_reports.getLength(); i++){
	    
	    Report r = new Report();
	    try{
		Node temp = in_reports.item(i);
		NodeList inl = temp.getChildNodes();
		
		//copy Title over
		Node inNode = getNodeByName("Title", inl);
		r.title = inNode.getFirstChild().getNodeValue();
		
		//copy Orig-URL over
		Node inNode1 = getNodeByName("Orig-URL", inl);
		r.origURL = inNode1.getFirstChild().getNodeValue();
		
		//copy Local-URL over
		Node inNode2 = getNodeByName("Local", inl);
		r.localURL=inNode2.getFirstChild().getNodeValue();
		
		//copy Age over
		Node inNode3 = getNodeByName("Age", inl);
		Long d = new Long(inNode3.getFirstChild().getNodeValue());
		
		r.age.setTime(d.longValue());
		
		r.viewable = false;
		
		if(!q_return.hasReport(r)){
		    System.out.println("++++Adding Report");
		    q_return.addReport(r);
		}
		
		//System.out.println(r.title + " " + r.origURL + " " + r.localURL + " " + r.age + " " + r.viewable);
	    }
	    catch(NullPointerException e) { System.err.print(e.getMessage());}
	}
	
	
	return q_return;
    }

    
    public boolean isFresh( String xmlFile ){


	DOMParser parser = new DOMParser();
	DOMParser allparser = new DOMParser();
	try {
	    parser.parse(xmlFile);
	    
	} catch (SAXException se) {
	    //    se.printStackTrace();
	} catch (IOException ioe) {
	    // ioe.printStackTrace();
	}
	try {
	   allparser.parse("XML_ALL.xml");
	    
	} catch (SAXException se) {
	    //se.printStackTrace();
	} catch (IOException ioe) {
	    //	    ioe.printStackTrace();
	}
	
	Document xml_all = allparser.getDocument();

	Document in_resp = parser.getDocument();
	//This document corresponds to a Query Result
	//We want to add it to the corresponding Query in XML_ALL

	//create a Node of type Report to add under a specific Query
	
	//get all of the query identifiers
	NodeList allqueries = xml_all.getElementsByTagName("QueryName");
	//get the query name of in_resp
	NodeList qs = in_resp.getElementsByTagName("QueryName");
	Node q = qs.item(0);
	String in_query = q.getFirstChild().getNodeValue();


	//keep track of which query matches the in_query
	int location = -1;

	for(int i=0; i<allqueries.getLength(); i++){
	    String s = allqueries.item(i).getFirstChild().getNodeValue();
	    //get all of the children
	    if (s.equals(in_query)) location=i;
	}

	//if the query already exists, add the summary to that query
	if (location != -1){

	    //get the reports from input	
	    NodeList in_reports = in_resp.getElementsByTagName("Report");

	    for (int i=0; i<in_reports.getLength(); i++){
		Node new_report = createReport(xml_all);
		
		NodeList newl = new_report.getChildNodes();	   
		
		Node temp = in_reports.item(i);
		NodeList inl = temp.getChildNodes();

		//copy Title over
		Node newNode = getNodeByName("Title", newl);
		Node inNode = getNodeByName("Title", inl);
		
		newNode.getFirstChild().setNodeValue(inNode.getFirstChild().getNodeValue());
		
		//copy URL over
		Node newNode1 = getNodeByName("Orig-URL", newl);
		Node inNode1 = getNodeByName("Orig-URL", inl);
		
		newNode1.getFirstChild().setNodeValue(inNode1.getFirstChild().getNodeValue());


		//copy Date over
		Node newNode2 = getNodeByName("Date", newl);
		Node inNode2 = getNodeByName("Date", inl);
		
		newNode2.getFirstChild().setNodeValue(inNode2.getFirstChild().getNodeValue());
		
		allqueries.item(location).appendChild(new_report);
		
	    }
	    
	}
	
	else {
	    //get the reports from input	
	    NodeList in_reports = in_resp.getElementsByTagName("Report");

	    //create a new query to put these reports into
	    Element new_query = xml_all.createElement("Query");
	    Element new_query_name = xml_all.createElement("QueryName");
	    new_query_name.appendChild( xml_all.createTextNode(in_query));
	    new_query.appendChild(new_query_name);
	        

	    for (int i=0; i<in_reports.getLength(); i++){
		Node new_report = createReport(xml_all);
	  
		NodeList newl = new_report.getChildNodes();	   
		
		Node temp = in_reports.item(i);
		NodeList inl = temp.getChildNodes();
		
		//copy Title over
		Node newNode = getNodeByName("Title", newl);
		Node inNode = getNodeByName("Title", inl);
		
		newNode.getFirstChild().setNodeValue(inNode.getFirstChild().getNodeValue());
		
		//copy URL over
		Node newNode1 = getNodeByName("Orig-URL", newl);
		Node inNode1 = getNodeByName("Orig-URL", inl);
		
		newNode1.getFirstChild().setNodeValue(inNode1.getFirstChild().getNodeValue());
		
		//copy Date over
		Node newNode2 = getNodeByName("Date", newl);
		Node inNode2 = getNodeByName("Date", inl);
		
		newNode2.getFirstChild().setNodeValue(inNode2.getFirstChild().getNodeValue());
		
		new_query.appendChild(new_report);
		Node top = xml_all.getElementsByTagName("XMLALL").item(0);
		top.appendChild(new_query);
		
		
		
	    }
	    
	}
	
	//NOw write the XML file back after modifications
	OutputFormat    format  = new OutputFormat( xml_all );   //Serialize DOM
	
	FileWriter fileOut=null;
	try{
	   fileOut = new FileWriter("XML_ALL.xml");        //Writer will be a File
	}catch(IOException e){System.out.println("XML Log File Not Found");}
	
	XMLSerializer    serial = new XMLSerializer( fileOut, format );
	try{serial.asDOMSerializer();                            // As a DOM Serializer
	serial.serialize( xml_all.getDocumentElement() );
	}catch (IOException e) {System.out.println("IO Error");}
	
	
	
	
	
	//For now return true until the configuration tool is set up
	return true;
	
    }
    
    
    
    
    
    
    public int addSummary(String summary, String origUrl){


	DOMParser allparser = new DOMParser();
	try {
	    allparser.parse("XML_ALL.xml");
	    
	} catch (SAXException se) {
	    //	    se.printStackTrace();
	} catch (IOException ioe) {
	    //	    ioe.printStackTrace();
	}
	
	Document xml_all = allparser.getDocument();

	
	//Get all of the URL elements in the xml file
	NodeList urls= xml_all.getElementsByTagName("Orig-URL");

	//Find the one with the value of origUrl
	int location = -1;
	for (int i=0; i<urls.getLength(); i++){
	    String s = urls.item(i).getFirstChild().getNodeValue();
	    if (s.equals(origUrl)) {
		location = i;
	    }
	}
	if (location == -1) return 0;
	else {
	    //get the parent node of this url
	    Node parent_report = urls.item(location).getParentNode();
	    
	    Node summ = getNodeByName("Summary", parent_report.getChildNodes());
	    Node readable = getNodeByName("readable", parent_report.getChildNodes());
	    
	    summ.getFirstChild().setNodeValue(summary);
	    readable.getFirstChild().setNodeValue("1");

	}
	
	//NOw write the XML file back after modifications
	OutputFormat    format  = new OutputFormat( xml_all );   //Serialize DOM
	
	FileWriter fileOut=null;
	try{
	    fileOut = new FileWriter("XML_ALL.xml");        //Writer will be a File
	}catch(IOException e){System.out.println("XML Log File Not Found");}
	
	XMLSerializer    serial = new XMLSerializer( fileOut, format );
	try{serial.asDOMSerializer();                            // As a DOM Serializer
	serial.serialize( xml_all.getDocumentElement() );
	}catch (IOException e) {System.out.println("IO Error");}
	
	return 1;
	

    }
    
    
    
	
    //Takes a nodelist of CDATA nodes
    private Node getNodeByName(String s, NodeList list){
	Node n=null;
	for (int i=0; i<list.getLength(); i++){
	    n=list.item(i);
	    if (n.getNodeName().equals(s)){
		return n;
	    }
	}
	return null;
    }

    private Node createReport(Document doc){
	 //create a new Report Element
	Element report = doc.createElement("Report");
	Element title =  doc.createElement("Title");
	title.appendChild( doc.createTextNode(" "));
	Element origurl =  doc.createElement("Orig-URL");
	origurl.appendChild( doc.createTextNode(" "));
	Element date =  doc.createElement("Date");
	date.appendChild( doc.createTextNode(" "));
	Element summary =  doc.createElement("Summary");
	summary.appendChild( doc.createTextNode(" "));
	Element readable =  doc.createElement("readable");
	readable.appendChild( doc.createTextNode("0"));
	
	report.appendChild(title);
	report.appendChild(origurl);
	report.appendChild(date);
	report.appendChild(summary);
	report.appendChild(readable);

	return report;
    }
	

}










