package GUIServer;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.*;
import Caching.*;


public class GenerateCacheViewer{

    public GenerateCacheViewer(){
    }
    
    public GenerateCacheViewer(Socket in_socket){
	
	try{
	    
	    OutputStream o = in_socket.getOutputStream();
	    
	    PrintWriter myout = new PrintWriter(o, true);
	    
	    myout.println("<HTML>  <HEAD>");
	    myout.println("<TITLE>Mobile Data Sharing Cache Configurator</TITLE>  </HEAD>");
	    myout.println("<FONT face=\"arial black\" size=7 color=\"blue\"><CENTER> <H3>Mobile Data Sharing Cache Configurator</H3></CENTER><BR><BODY bgcolor=\"white\" text=\"navy\" marginwidth=\"0\" marginheight=\"0\" leftmargin=\"0\" topmargin=\"0\">");
	    
	    
	    //Get the cache buffer so we can pull the values out of it
	    CacheBuffer cb = CacheBuffer.getInstance();

	    //cb.Tree = new CacheTreeNode();
	    
	    Object[] arr = cb.giveBuffer().values().toArray();
	    BufferEntry be = new BufferEntry();
	    
	    int size = Array.getLength(arr);
	    System.out.println("The buffer has " + size + " entries");
	    
	    for(int i=0; i<size; i++){
		be = (BufferEntry)arr[i];
		System.out.println(be.getUrl());
		//Add this buffer entry to the Tree;
		//cb.Tree.add(be.getUrl());
		
	    }

	    // cb.Tree.printTree(cb.Tree);
	    
	    //Nowe deal with the Tree for printing out items
	    myout.println("<TABLE BORDER=0><form>");
	    
	    printTree(cb.Tree, myout);
	    
	    
	    myout.println("</form></TABLE></BODY></FONT></HTML>");
	    
	    
	}
	catch (IOException e) {System.err.println(e.getMessage());
	}
	
	
    }
    
    
    
    void printTree( CacheTreeNode intree, PrintWriter myout){

	CacheBuffer cb = CacheBuffer.getInstance();
	System.out.println("********" + intree.getGlobal() + " " + intree.expanded + " " + intree.root);
	if(intree.expanded || intree.root){
	    for( int i=0; i<intree.children.size(); i++){
		
		CacheTreeNode ctn= intree.getChild(i);
		myout.println("<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0>");
		
		//Check for a leaf node
		if (ctn.children.size()==0){
		    
		    if (  cb.getBufferEntry( "http:/" + ctn.getGlobal() ) != null) {
			if (  cb.getBufferEntry( "http:/" + ctn.getGlobal() ).getFolder().equals("private")){ 
			    
			    myout.println(" <TR VALIGN=middle>");
			    
			    for(int k=0; k<ctn.depth; k++) myout.println("<TD WIDTH=25></TD>");
			    
			    myout.println("<TD WIDTH=25><IMG SRC=\"LOCK*&*\" height=25 width=30></TD><TD WIDTH=25><input type=\"button\" value=\"unsecure\" OnClick=\"javascript:window.open('/SECUREOFF*&*" + ctn.getGlobal() + "&&','CacheViewer')\">");   
			    
			    myout.println("</TD> ");
			}
			else {
			    
			    myout.println(" <TR VALIGN=middle>");
			    
			    for(int k=0; k<ctn.depth; k++) myout.println("<TD WIDTH=25></TD>");
			    
			    myout.println("<TD WIDTH=25><IMG SRC=\"LOCKOFF*&*\" height=25 width=30></TD><TD WIDTH=25> <input type=\"button\" value=\"secure\" OnClick=\"javascript:window.open('/SECURE*&*" + ctn.getGlobal() + "&&','CacheViewer')\">");   
			    
			    myout.println("</TD> ");
			    
			}
			
			myout.println("<TD WIDTH=25><INPUT TYPE=\"BUTTON\"VALUE=\"Details\" OnClick=\"javascript:window.open('/SHOWMORE&" + ctn.getGlobal() + "&&','DetailsViewer','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=600,height=200')\"></TD>");
			
			
			myout.println("<TD VALIGN=middle>"+  ctn.getLocal() + "</TD>");
			
			myout.println(" </TR> ");
		    }
		    myout.println("</TABLE>");
		    
		}
		
		//Otherwise we have a parent node and it needs to be printed had have it's children
		//printed out as well.
		else{
		    
		    myout.println(" <TR VALIGN=middle>");
		    for(int k=0; k<ctn.depth; k++) myout.println("<TD WIDTH=25></TD>");
		    
		    myout.println("<TD VALIGN=middle><input type=\"button\" value=\"unsecure\" OnClick=\"javascript:window.open('/SECUREOFF*&*" + ctn.getGlobal() + "&&','CacheViewer')\">");   
		    
		    myout.println("</TD> ");
		    
		    myout.println(" <TD VALIGN=middle><input type=\"button\" value=\"secure\" OnClick=\"javascript:window.open('/SECURE*&*" + ctn.getGlobal() + "&&','CacheViewer')\">");   
		    
		    
		    myout.println("</TD> ");
		    
		    myout.println("<TD VALIGN=middle>" + "<a href=\"cacexp:" + ctn.getGlobal() + "&&\">" + ctn.getLocal() + "</a>" + "</TD>");
		    
		    myout.println(" </TR> ");
		    myout.println("</TABLE>");
		    
		    
		    printTree(ctn, myout);
		    
		    
		}
		
	    }
	}
    }
	







}








