//Class for the Query Report Buffer to be used in the GUIServer
package GUIServer;

import java.util.*;
import WebClient.*;
import Caching.*;

//A QueryReportBuffer will merely contain a list of objects of
//the type Query

import StartAllServers.Debug;
public class QueryReportBuffer{
    
    private static QueryReportBuffer myself;

    private QueryReportBuffer() {
	//set me up
    }

    public static synchronized QueryReportBuffer getInstance() {
	if (myself == null) {
	    myself = new QueryReportBuffer();
	}
	return myself;
    }


    public static int updatefreq = 40;   //This should really be refresh frequency of main page
    public static int broadcastfreq = 5;
    public static int numbroadcasts = 10; 
    public static int bufferfreq = 30;
    public static int cleancache = 2;
    public static int expires = 1;   //expires after x hours
    public static boolean energy = false;

    
    static Vector queries = new Vector();
    //A Query will contain a list of reports and an identifier, 
    //the query string itself
    
    public static void addResponse(String xml_report){

	//System.out.println("+++++++++++adding response to queryReport.. " + xml_report);
	//System.out.println("----------In add response memory location is: " + queries.toString());
	//takes a report in the form of an xml string, gets the QueryDescriptor
	//and adds the report to an existing or a new query.
	
	Response r = new Response();
	xml_report=xml_report.trim();
	Query q = r.parseResponse(xml_report);
	int location;

	//hasQuery returns -1 if false
	if (( location = hasQuery(q.descriptor) )==-1 ) 
	    queries.addElement(q);
	
	else {
	    // if the query already exists, add the reports within the query
	    //we have parsed into the existing query at location

	    for(int i=0; i<q.reports.size(); i++){
		try{
		    ((Query)queries.elementAt(location)).addReport((Report)q.reports.elementAt(i));
		}catch(NullPointerException e){System.err.print(e.getMessage());}
	    }
	}

	//	for (int i=0; i<queries.size(); i++){
	//  Query qi;
	    //	    System.out.println( (qi=(Query)queries.elementAt(i)).descriptor);
	    //	    for(int j=0; j<qi.reports.size(); j++){
	    //System.out.println( ((Report)qi.reports.elementAt(j)).title);
	    //System.out.println( ((Report)qi.reports.elementAt(j)).origURL);
	    //System.out.println( ((Report)qi.reports.elementAt(j)).localURL);
	    //System.out.println( ((Report)qi.reports.elementAt(j)).age);
	    //}
	//}

	
    }


    //sets the expanded value for the query with the given descriptor to true
    public void expandQuery(String desc){

	//	Integer index = new Integer(desc);
	       
       	int which = new Integer(desc).intValue();

if (Debug.DEBUG_GUIServer == true) { 
 	 System.out.println("hasQuery returns " + hasQuery(desc) + queries.size()); 
 	}
	/*	if ( (which = hasQuery(desc)) != -1  ){*/
	
if (Debug.DEBUG_GUIServer == true) { 
 	 System.out.println("EEEEEEEXPANDING " + desc + "OOO"); 
 	}
	try{
	    boolean exp = ((Query)queries.elementAt(which)).expanded;
	    
	    if (exp) ((Query)queries.elementAt(which)).expanded=false;
	    else ((Query)queries.elementAt(which)).expanded=true;
	}
	catch(NullPointerException e){ System.out.println("ATTENTION:  Reload GUI Page");}
    }
    
    
    
    public static int hasQuery(String repName){
	//Returns the location of the query that has that 
	//same query descriptor
	
	for(int i=0; i<queries.size(); i++){
	    if ( ((Query)queries.elementAt(i)).descriptor.equals(repName))
		return i;
	}
	return -1;
	
    }

    public static void retrieveLatestPages(){

if (Debug.DEBUG_GUIServer == true) { 
 	 System.out.println("----RETRIEVE LATEST PAGES The memory location is: " + queries.toString()); 
 	}
	for (int i=0; i<queries.size(); i++){
	    System.out.println("MMMMMMMMMMMMMMaking Call to findLatest in QRB.java");
	    ( (Query)queries.elementAt(i) ).findLatestReport();
	}


	/*	    HandleWebPage hp = new HandleWebPage();
		    if(retURL != null  && (!hp.FileisInCache( stripHostname(retURL) ) ) ){
		    
		    if (Debug.DEBUG_GUIServer == true) { 
		    System.out.println("+++++++++Retrieving page " + retURL); 
		    }
		    
		    WebRetrieve myclient = new WebRetrieve(retURL);
		    boolean cached = myclient.sendRequest();
		    
		    if(cached){
		    if (Debug.DEBUG_GUIServer == true) { 
		    System.out.println("^^^^^^^^^Setting " + retURL + "to viewable"); 
		    }
		    retURL = retURL.trim();
		    setViewable(retURL);
		    }
		    //set the viewable variable to true for the query at hand
		    }
		    
		    //if it happens successfully, we set the viewable variable to true for all 
		    //reports with that URL
		    }
	*/
	
    }
    
    
    //created for the GenerateSearch page so that it can show the query was submitted
    //before any reports for it are returned
    
    public static void addQuery(String descriptor){
	if(hasQuery(descriptor) == -1){
	    Query q = new Query();
	    q.descriptor = descriptor;
	    queries.addElement(q);
	}
    }
    

    
}


	    






