package UDPMulticast;
import java.io.*;
import java.net.*;
import java.util.*;
import UDPUnicast.*;
import Caching.*;
import StartAllServers.Debug;
import StartAllServers.*;
import Misc.Battery;
import HTTPMethods.*;

public class MulticastReceiveThread extends Thread {

    int multicast_socket_port;

    public MulticastReceiveThread (int msp) {
	super("MultiCastReceiveThread");
	this.multicast_socket_port = msp;
    }
	
    public void run() {

	//the socket to listen on
	try {
	    MulticastSocket socket = new MulticastSocket(multicast_socket_port);
if (Debug.DEBUG_UDPMulticast == true) { 
 	 System.out.println("Multicast Listening on: " + multicast_socket_port); 
 	}
	    //the group address
	    InetAddress address = InetAddress.getByName(StartAllServers.REPORT_REQUEST_GROUP_ADDRESS);
	    socket.joinGroup(address);
     
	    DatagramPacket packet;
	    
	    // continuously receive stuff
	    boolean test = true;
	    while(test) {
		  //end_time > System.currentTimeMillis()) {
		
		byte[] buf = new byte[1024];
		packet = new DatagramPacket(buf, buf.length);
		try {
		socket.receive(packet);
		
		InetAddress origin_host =  packet.getAddress();
		if (Debug.DEBUG_UDPMulticast == true) { 
		    System.out.println("This packet originated from: " + origin_host.toString()); 
		}
		
		//don't accept packets you send yourself
		if (!InetAddress.getLocalHost().equals(origin_host)) {
		    
		    
		    String received = new String(packet.getData());
		    if (Debug.DEBUG_UDPMulticast == true) { 
			System.out.println("********MULTICAST_RECEIVED: " + received); 
		    }
		    
		    //Here I have received a request 
		    //OUTLINE OF INTEGRATION REASONING WITH FANG's CODE
		    SearchEngine sEngine = new SearchEngine();
		    HandleWebPage wp = new HandleWebPage();
		    String report;
		
		    int beg = received.indexOf("<Query>") + 7;
		    int end = received.indexOf("</Query>");
		    String query = received.substring(beg, end);
		   
		    Battery bt = Battery.getInstance();
		    System.out.println("Before replying to multicast - ");
		    bt.printBatteryLevel();
		    System.out.println("The query is: " + query);

		    if (bt.batteryOK()) {			
			if (query.trim().startsWith("http://") && wp.FileisInCache(query.trim(), true)) {
			    // report = sEngine.getDescriptor(ParseRequest.attachIndexHtml(query));
			    report = sEngine.getURLFromCache(query);
			    
			    
			    if (report != null) {
				UDPUnicastSender Sender = new UDPUnicastSender(origin_host.getHostAddress());
				//send it to a pre-determined port only once
				Sender.sendMess(report, 1);
			    }
			}
			
			
			else if ((query != null) && ((report = sEngine.getReport(query)) != null)) {
			    //report = sEngine.getReport(query);
			    
			    if (report != null) {
				UDPUnicastSender Sender = new UDPUnicastSender(origin_host.getHostAddress());
				//send it to a pre-determined port only once
				Sender.sendMess(report, 1);
			    }
			}
			else {}
		    }
		}
		
		    //fulfill the request if it is in the Cache
		    //new ReplyerThread(received).start();
		    
		} catch (IOException e) {
		    if (Debug.DEBUG_UDPMulticast == true) { 
			System.out.println("MULTICAST_RECEIVE_THREAD - Receive Failed: " + e.getMessage() + "\nCurrent time is: " + System.currentTimeMillis()); 
		    }
		    continue;
		}
		
	    }
	    
		
		socket.leaveGroup(address);
		socket.close();
	} catch (IOException e) {
	    if (Debug.DEBUG_UDPMulticast == true) { 
		System.out.println("MULTICAST_RECEIVE_THREAD - An IOException has been thrown: " + e.getMessage()); 
	    }
	}
    }
}
