package UDPUnicast;
import java.io.*;
import java.net.*;
import java.util.*;
import WebClient.*;
import GUIServer.*;

import StartAllServers.Debug;
public class UDPUnicastReceiverHelper extends Thread {

    protected DatagramSocket socket = null;

    public UDPUnicastReceiverHelper(int port) {
	super("UDPUnicastReceiverHelper");
	try {
	    this.socket = new DatagramSocket(port);
	} catch (SocketException e) {
	    System.err.println("Socket Exception: " + e.getMessage());
	}
    }

    public void run() {

	byte[] buf = new byte[64000];
	
	// receive request
	DatagramPacket packet = new DatagramPacket(buf, buf.length);
	boolean test = true;
	while(test) {
	    try {
		socket.receive(packet);
	    } catch (IOException e) {
		System.err.println("IOException: " + e.getMessage());
	    }
	    byte[] received = packet.getData();

	    if (Debug.DEBUG_UDPUnicast == true) { 
		System.out.println("**********Received report from:" + packet.getAddress().getHostAddress()); 
	    }
	    if (Debug.DEBUG_UDPUnicast == true) { 
		System.out.println("**********Report Received is:" + new String(received).toString() + "\n"); 
	    }

	    //send a note to Joe that we just got a report
	    report(new String(received).toString());
	    
	}

        socket.close();
    }

    public synchronized void report (String xmlReport) {
	QueryReportBuffer mybuffer = QueryReportBuffer.getInstance();
	mybuffer.addResponse(xmlReport);
    }
}








