package UDPUnicast;
import java.io.*;
import java.net.*;
import java.util.*;
import StartAllServers.Debug;
import StartAllServers.*;

public class UDPUnicastSender {
    
    DatagramSocket socket;
    DatagramPacket packet;
    byte[] buf;
    InetAddress address;
    String hostname;

    public UDPUnicastSender(String hostname) {

	try {
	this.socket = new DatagramSocket();
	} catch (SocketException e) {
	    System.err.println("Socket exception: " + e.getMessage());
	}
	
	this.hostname = hostname;
    }

    public void sendMess(String message, int num_times) {
	int to_port = StartAllServers.SEND_REPORTS_ON_PORT;

	while(num_times > 0) {
	    num_times--;

	    // send request
	    if (Debug.DEBUG_UDPUnicast == true) { 
		System.out.println("In SendMESS: " + message); 
	    }
	    buf = new String(message).getBytes();

	    try {
		
		address = InetAddress.getByName(hostname);
	    } catch (IOException e) {
		System.err.println("IOException: " + e.getMessage());
	    }
	    
	    packet = new DatagramPacket(buf, buf.length, address, to_port);
	    
	    try {
		socket.send(packet);
	    } catch (IOException e) {
		System.err.println("IOException: " + e.getMessage());
	    }
	    
	    try {
		Thread.sleep(2000);
	    } catch (InterruptedException e) {
		if (Debug.DEBUG_UDPUnicast == true) { 
		    System.out.println("Error with sleep: " + e.getMessage()); 
		}
	    }
	}
	
        socket.close();
    }

    public static void main(String[] args) throws IOException {

	String message = "http://10.0.0.1";
	int to_port = 9002;

	//should really be something like
	//to_port = StartAllServers.UDP_unicast_port;

	UDPUnicastSender Sender = new UDPUnicastSender("localhost");
	Sender.sendMess(message, 10);
    }
}
