package WebClient;

import HTTPClient.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import Caching.*;
import java.util.*;

import StartAllServers.Debug;
public class WebRetrieve {

    URL myurl;
    String host;
    int port;
    String path;
    String file;
    String real_host;

    public WebRetrieve(String url) {
	parseURL(url); 
    }

    public void parseURL(String URLstring) {
	try {
if (Debug.DEBUG_WebClient == true) { 
 	 System.out.println("In constructor the URL string is: " + URLstring); 
 	}
	    this.myurl = new URL(URLstring);
	    this.host = myurl.getHost();
	    this.port = myurl.getPort();
	    if (port == -1) {
		port = 80;
	    }
		    
	    this.path = myurl.getPath();
	    this.file = myurl.getFile();
	} catch (MalformedURLException e) {
	    System.out.println("Getting Malformed URL Exception");
	    System.err.println(e.getMessage());
	}

    }


    public void parseText(String myhtml) {
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("In parse text"); 
 	}
	StringTokenizer mytoken = new StringTokenizer(myhtml, "<>");
	while (mytoken.hasMoreElements()) {
	    String test = mytoken.nextToken();
	    if (test.toUpperCase().indexOf("IMG SRC") > -1) {
		
		//usually the syntax is <IMG SRC = "http://something"
		StringTokenizer temp = new StringTokenizer(test, "= ", false);
		temp = new StringTokenizer(test, "= ", false);
		if (temp.countTokens() > 3) {
		    temp.nextToken();
		    temp.nextToken();
		    String url = temp.nextToken();
		    if (Debug.DEBUG_WebClient == true) { 
			System.out.println("Url is " + url); 
		    }
		    url = clean_url(url);
		    WebRetrieve myWebClient = new WebRetrieve(url);
		    myWebClient.sendRequest();
		}
	    }
	    
	}
    }
    
    //form an absolute URL from a relative one
    public String clean_url(String url) {
	url = url.trim();
	StringBuffer urls = new StringBuffer(url);
	if (urls.charAt(0) == '"')
	    urls.deleteCharAt(0);
	if (urls.charAt(urls.length()-1) == '"') 
	    urls.deleteCharAt(urls.length()-1);
	
	if (urls.toString().startsWith("http://")) { 
	    urls.insert(6, "/" +  host + ":" + port);
	    if (Debug.DEBUG_WebClient == true) { 
		System.out.println("Final result is " + urls.toString()); 
	    }
	    return urls.toString();
	}
	
	if (urls.charAt(0) != '/') {
	    urls.insert(0, path.substring(0, path.lastIndexOf("/")+1));
	    urls.insert(0, "http://" + host + ":" + port );
	    if (Debug.DEBUG_WebClient == true) { 
		System.out.println("Final result is " + urls.toString()); 
	    }
	    return urls.toString();
	}
	
	urls.insert(0, "http://" + host + ":" + port + "/" + real_host );
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("Final result is: " + urls.toString()); 
 	}
	return urls.toString();
    }
    
    
    //just take out the IP of the host where this page came from
    public String avoidPropagation() {
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("The path is: " + path); 
 	}
	
	//global variable describing this connection
	int start = path.indexOf("/");
	int end = path.indexOf("/", start+1);
	this.real_host = path.substring(start+1,end);
	
	if (Debug.DEBUG_WebClient == true) { 
	    System.out.println("The real host is:" + this.real_host); 
 	}
	String new_url =  "http:/" + path;
	if (new_url.trim().endsWith("/")) 
	    new_url =  new_url.trim().concat("index.html");
	System.err.println("Propagation URL is: " + new_url);
	return new_url;
    }
    
    
    
    public boolean sendRequest() {
	byte[] data;
	HTTPConnection con = new HTTPConnection(host, port);
	
	try {
	    System.out.println("***THE GET REQUEST IS: GET " + path);
	    HTTPResponse rsp = con.Get(path);
	    
	    if (rsp.getStatusCode() >= 400) {
		if (Debug.DEBUG_WebClient == true) { 
		    System.out.println("File doesn't exist on: " + host + " filename: " + path); 
		}
		//don't need to save anything in this case
	    }
	    
	    else {
		
		data = rsp.getData();
		String url_temp = avoidPropagation();
		HandleWebPage hp = new HandleWebPage();

		hp.cache(new URL(url_temp), rsp, data);
		if (Debug.DEBUG_WebClient == true) { 
		    System.out.println("After cache"); 
		}
		String type = rsp.getHeader("Content-Type");
		if (Debug.DEBUG_WebClient == true) { 
		    System.out.println("The type is: " + type); 
		}
		if (type.startsWith("text")) {
		    parseText(new String(data));
		}
	    }
	} catch (Exception e) {
	    System.err.println(e.getMessage());
	    return false;
	}
	return true;
    }
    
    
    public static void main(String[] args) {
	
	String URL = "http://128.59.15.37:9000/www.cs.brandeis.edu/index.html";
	WebRetrieve myWebClient = new WebRetrieve(URL);
        myWebClient.sendRequest();
    }
}










